/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This file is part of the bit library.                                 *
 *                                                                         *
 *   The bit library is free software; you can redistribute it and/or      *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The bit library is distributed in the hope that it will be useful,    *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef BITFACTORY_H
#define BITFACTORY_H

#include <bit/fieldbase.h>
#include <bit/fieldtype.h>
#include <bit/field.h>
#include <bit/fieldvector.h>
#include <bit/record.h>
#include <bit/recordvector.h>

namespace bit {

  extern std::vector<std::string> xml_file_load_path;

  void initialize_xml_file_load_path();

  RecordBase::pointer xml_load_file(const std::string& filename);
  RecordBase::pointer xml_load_memory(const std::string& string);
  RecordBase::pointer xml_load_memory_raw(const unsigned char *contents, size_t bytes_count);
  RecordBase::pointer xml_load_stream(std::istream &in);

  RecordBase::pointer xml_read_record(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS, const FieldType& default_type=FieldType());

  Field::pointer xml_read_field(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS, const FieldType& default_type=FieldType());

  FieldType xml_read_type(xmlpp::Element& xml_element);

  void xml_read_skip(xmlpp::Element& xml_element, int& last_position, size_t length_units=BITS, size_t offset_units=BITS);

  size_t get_units(std::string s);

  std::string get_xml_file_as_string(const std::string& filename);
}

#endif
